#include "testlib.h"
#include <bits/stdc++.h>
//#define int long long
using namespace std;
const int A=1'000'000'000;
const long long INF=1'000'000'000'000'000'000;
int main(int argc, char *argv[]) {
    registerValidation(argc, argv);
    long long n=inf.readInt(1,A,"N");
    inf.readSpace();
    long long k=inf.readLong(1,INF,"K");
    inf.readEoln();
    long long group = atoi(validator.group().c_str());
    ensure(!(group==1 && !(k<=20 && n<=5)));
    ensure(!(group==2 && !(k<=1'000'000 && n<=1'000'000)));
    ensure(!(group==3 && !(k<=A && n<=A)));
    ensure(!(group==4 && !(k<=INF && n<=A)));
    inf.readEof();
}
